#pragma once
#include <iostream>
#include <vector>
#include "glibmm.h"
#include "giomm.h"

namespace gnome {
namespace SessionManager {

class ClientPrivateTypeWrap {
public:
    template<typename T>
    static void unwrapList(std::vector<T> &list, const Glib::VariantContainerBase &wrapped) {
        for (uint i = 0; i < wrapped.get_n_children(); i++) {
            Glib::Variant<T> item;
            wrapped.get_child(item, i);
            list.push_back(item.get());
        }
    }

    static std::vector<Glib::ustring> stdStringVecToGlibStringVec(const std::vector<std::string> &strv) {
        std::vector<Glib::ustring> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static std::vector<std::string> glibStringVecToStdStringVec(const std::vector<Glib::ustring> &strv) {
        std::vector<std::string> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static Glib::VariantContainerBase EndSessionResponse_pack(
        bool arg_is_ok,
        const Glib::ustring & arg_reason) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::Variant<bool> is_ok_param =
            Glib::Variant<bool>::create(arg_is_ok);
        params.push_back(is_ok_param);

        Glib::Variant<Glib::ustring> reason_param =
            Glib::Variant<Glib::ustring>::create(arg_reason);
        params.push_back(reason_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }
};

} // SessionManager
} // gnome


