#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-session-manager-2.1.2/generated/session_manager_dbus_common.h"

namespace gnome {

class SessionManagerProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<SessionManagerProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<SessionManagerProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void RegisterClient(
        const Glib::ustring & app_id,
        const Glib::ustring & client_startup_id,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RegisterClient_finish (
        Glib::DBusObjectPathString &client_id,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::DBusObjectPathString
    RegisterClient_sync(
        const Glib::ustring & app_id,        const Glib::ustring & client_startup_id,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Inhibit(
        const Glib::ustring & app_id,
        guint32 toplevel_xid,
        const Glib::ustring & reason,
        guint32 flags,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Inhibit_finish (
        guint32 &inhibit_cookie,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    guint32
    Inhibit_sync(
        const Glib::ustring & app_id,        guint32 toplevel_xid,        const Glib::ustring & reason,        guint32 flags,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Uninhibit(
        guint32 inhibit_cookie,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Uninhibit_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Uninhibit_sync(
        guint32 inhibit_cookie,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void IsInhibited(
        guint32 flags,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void IsInhibited_finish (
        bool &is_inhibited,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    bool
    IsInhibited_sync(
        guint32 flags,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInhibitor(
        guint32 cookie,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInhibitor_finish (
        Glib::ustring &inhibitor,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetInhibitor_sync(
        guint32 cookie,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInhibitors(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInhibitors_finish (
        Glib::ustring &inhibitors,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetInhibitors_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Shutdown(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Shutdown_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Shutdown_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestShutdown(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestShutdown_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    RequestShutdown_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanShutdown(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanShutdown_finish (
        bool &is_available,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    bool
    CanShutdown_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Logout(
        guint32 mode,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Logout_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Logout_sync(
        guint32 mode,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanLogout(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanLogout_finish (
        bool &is_available,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    bool
    CanLogout_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Reboot(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Reboot_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Reboot_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestReboot(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestReboot_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    RequestReboot_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanReboot(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CanReboot_finish (
        bool &is_available,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    bool
    CanReboot_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    sigc::signal<void, guint32 > InhibitorAdded_signal;
    sigc::signal<void, guint32 > InhibitorRemoved_signal;
    sigc::signal<void, gint32 > PhaseChanged_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    SessionManagerProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

};

}// gnome

