#pragma once
#include <string>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-session-manager-2.1.2/generated/session_manager_dbus_common.h"

namespace gnome {

class SessionManagerStub : public sigc::trackable {
public:
    SessionManagerStub();
    virtual ~SessionManagerStub();

    SessionManagerStub(const SessionManagerStub &other) = delete;
    SessionManagerStub(SessionManagerStub &&other) = delete;
    SessionManagerStub &operator=(const SessionManagerStub &other) = delete;
    SessionManagerStub &operator=(SessionManagerStub &&other) = delete;

    guint register_object(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                          const Glib::ustring &object_path);
    void unregister_object();

    unsigned int usage_count() const {
        return static_cast<unsigned int>(m_registered_objects.size());
    }

    class MethodInvocation;

protected:
    virtual void RegisterClient(
        const Glib::ustring & app_id,
        const Glib::ustring & client_startup_id,
        MethodInvocation &invocation) = 0;
    virtual void Inhibit(
        const Glib::ustring & app_id,
        guint32 toplevel_xid,
        const Glib::ustring & reason,
        guint32 flags,
        MethodInvocation &invocation) = 0;
    virtual void Uninhibit(
        guint32 inhibit_cookie,
        MethodInvocation &invocation) = 0;
    virtual void IsInhibited(
        guint32 flags,
        MethodInvocation &invocation) = 0;
    virtual void GetInhibitor(
        guint32 cookie,
        MethodInvocation &invocation) = 0;
    virtual void GetInhibitors(
        MethodInvocation &invocation) = 0;
    virtual void Shutdown(
        MethodInvocation &invocation) = 0;
    virtual void RequestShutdown(
        MethodInvocation &invocation) = 0;
    virtual void CanShutdown(
        MethodInvocation &invocation) = 0;
    virtual void Logout(
        guint32 mode,
        MethodInvocation &invocation) = 0;
    virtual void CanLogout(
        MethodInvocation &invocation) = 0;
    virtual void Reboot(
        MethodInvocation &invocation) = 0;
    virtual void RequestReboot(
        MethodInvocation &invocation) = 0;
    virtual void CanReboot(
        MethodInvocation &invocation) = 0;

    void InhibitorAdded_emitter(const std::vector<Glib::ustring> &destination_bus_names, guint32);
    sigc::signal<void, guint32> InhibitorAdded_signal;
    sigc::signal<void, const std::vector<Glib::ustring>&, guint32> InhibitorAdded_selectiveSignal;

    void InhibitorRemoved_emitter(const std::vector<Glib::ustring> &destination_bus_names, guint32);
    sigc::signal<void, guint32> InhibitorRemoved_signal;
    sigc::signal<void, const std::vector<Glib::ustring>&, guint32> InhibitorRemoved_selectiveSignal;

    void PhaseChanged_emitter(const std::vector<Glib::ustring> &destination_bus_names, gint32);
    sigc::signal<void, gint32> PhaseChanged_signal;
    sigc::signal<void, const std::vector<Glib::ustring>&, gint32> PhaseChanged_selectiveSignal;

    void on_method_call(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                        const Glib::ustring &sender,
                        const Glib::ustring &object_path,
                        const Glib::ustring &interface_name,
                        const Glib::ustring &method_name,
                        const Glib::VariantContainerBase &parameters,
                        const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation);

    void on_interface_get_property(Glib::VariantBase& property,
                                   const Glib::RefPtr<Gio::DBus::Connection> &connection,
                                   const Glib::ustring &sender,
                                   const Glib::ustring &object_path,
                                   const Glib::ustring &interface_name,
                                   const Glib::ustring &property_name);

    bool on_interface_set_property(
        const Glib::RefPtr<Gio::DBus::Connection> &connection,
        const Glib::ustring &sender,
        const Glib::ustring &object_path,
        const Glib::ustring &interface_name,
        const Glib::ustring &property_name,
        const Glib::VariantBase &value);

private:
    bool emitSignal(const std::string &propName, Glib::VariantBase &value);

    struct RegisteredObject {
        guint id;
        Glib::RefPtr<Gio::DBus::Connection> connection;
        std::string object_path;
    };

    Glib::RefPtr<Gio::DBus::NodeInfo> introspection_data;
    std::vector<RegisteredObject> m_registered_objects;
    std::string m_interfaceName;
};

class SessionManagerStub::MethodInvocation {
public:
    MethodInvocation(const Glib::RefPtr<Gio::DBus::MethodInvocation> &msg):
        m_message(msg) {}

    const Glib::RefPtr<Gio::DBus::MethodInvocation> getMessage() {
        return m_message;
    }

    void ret(Glib::Error error) {
        m_message->return_error(error);
    }

    void returnError(const Glib::ustring &domain, int code, const Glib::ustring &message) {
        m_message->return_error(domain, code, message);
    }

    void ret(const Glib::DBusObjectPathString & p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::VariantStringBase var0;
        Glib::VariantStringBase::create_object_path(var0, p0.c_str());
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(guint32 p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<guint32> var0 =
            Glib::Variant<guint32>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret() {
        std::vector<Glib::VariantBase> vlist;

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(bool p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<bool> var0 =
            Glib::Variant<bool>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(const Glib::ustring & p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<Glib::ustring> var0 =
            Glib::Variant<Glib::ustring>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

private:
    Glib::RefPtr<Gio::DBus::MethodInvocation> m_message;
};

} // gnome

